import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.imageio.*;

/**
 * plNX
 */
public class MGPanel extends JPanel {

	/** tF[Y */
	private		int					phase				= 0;

	/** }EXA_v^ */
	private		MGMouseAdapter		mgma				= null;

	/** sRsRn}[W */
	private		int					px					= 0;
	/** sRsRn}[W */
	private		int					py					= 0;

	/** W */
	private		int					mx					= 350;
	/** W */
	private		int					my					= 200;

	/** wi */
	private		BufferedImage		imageBackground		= null;

	/** sRsRn}[ */
	private		BufferedImage[]		imagePHs			= null;
	/** sRsRn}[ */
	private		int					ph					= 0;

	/**  */
	private		BufferedImage[]		imageMs				= null;
	/**  */
	private		int					m					= 0;
	/** ̎ */
	private		int					timeM				= 0;

	/** ^C}[ */
	private		java.util.Timer		timerThis			= null;

	/** _ */
	private		int					score				= 0;
	private		Font				fontScore			= new Font("lr SVbN", Font.BOLD | Font.ITALIC, 24);

	/**  */
	private		int					time				= 1859;
	private		Font				fontTime			= new Font("lr SVbN", Font.BOLD, 24);

	/** Q[I[o[ */
	private		Font				fontGameOver		= new Font("lr SVbN", Font.BOLD, 48);

	/** BGM */
	private		KSoundMidi			midiMoguraDance		= null;

	/** ʉ */
	private		KSoundWave			waveMoguraDeru		= null;
	private		KSoundWave			wavePicoHammerMiss	= null;
	private		KSoundWave			wavePicoHammerHit	= null;

	/**
	 * RXgN^
	 */
	public MGPanel() {

		// X[p[NXĂяo
		super();

		try{

			// plTCY
			super.setPreferredSize(new Dimension(800, 600));
			// CAEgݒ
			super.setLayout(null);

			// }EXA_v^𐶐
			mgma = new MGMouseAdapter();
			// plɃ}EXXi[ǉ
			super.addMouseListener(mgma);
			super.addMouseMotionListener(mgma);

			// wiǂݍ
			InputStream isBackground = this.getClass().getResourceAsStream("Background.jpg");
			imageBackground = ImageIO.read(isBackground);
			isBackground.close();

			// sRsRn}[ǂݍ
			imagePHs = new BufferedImage[2];
			InputStream isPH00 = this.getClass().getResourceAsStream("PH00.gif");
			imagePHs[0] = ImageIO.read(isPH00);
			isPH00.close();

			InputStream isPH01 = this.getClass().getResourceAsStream("PH01.gif");
			imagePHs[1] = ImageIO.read(isPH01);
			isPH01.close();

			// ǂݍ
			imageMs = new BufferedImage[2];
			InputStream isM00 = this.getClass().getResourceAsStream("M00.gif");
			imageMs[0] = ImageIO.read(isM00);
			isM00.close();

			InputStream isM01 = this.getClass().getResourceAsStream("M01.gif");
			imageMs[1] = ImageIO.read(isM01);
			isM01.close();

			// BGM𐶐
			midiMoguraDance = new KSoundMidi(this, "sound\\MoguraDance.mid", false);

			// ʉ𐶐
			waveMoguraDeru = new KSoundWave(this, "sound\\MoguraDeru.wav", false);
			wavePicoHammerMiss = new KSoundWave(this, "sound\\PicoHammerMiss.wav", false);
			wavePicoHammerHit = new KSoundWave(this, "sound\\PicoHammerHit.wav", false);

			// 
			init();

			// ^C}[𐶐
			timerThis = new java.util.Timer();

			// ^C}[X^[g
			timerThis.scheduleAtFixedRate(new TimerActionTimerTask(), 1000l, 16l);

		}catch(Exception ex){
			ex.printStackTrace();
			JOptionPane.showMessageDialog(this, "ERROR : " + ex.toString());
		}

	} // end MGPanel

	/**
	 * 
	 */
	public void init(){

		// tF[YQ[ɂ
		phase = 0;
		// ̏
		m = 0;
		// _
		score = 0;
		// 
		time = 1859;

		// BGM
		midiMoguraDance.init();
		// BGMX^[g
		midiMoguraDance.start();

	} // end init

	/**
	 * s
	 */
	public void run(){

		// tF[Y
		switch(phase){

			case 0:

				// Ԃ炷
				time--;

				// ԂA
				if(time == 0){
					// Ԃ߂
					time = 300;
					// tF[YύX
					phase = 1;
					// uCN
					break;
				}

				// ĂꍇA
				if(timeM != 0){

					// Ԃ|P
					timeM--;

					// ԂOɂȂ
					if(timeM == 0){

						// V\
						m = 0;

						mx = (int)(Math.random() * 550);
						my = (int)(Math.random() * 450);

						// ʉX^[g
						waveMoguraDeru.start();

					} // end if ԂOɂȂ

				} // end if Ăꍇ

				// uCN
				break;

			case 1:

				// Ԃ炷
				time--;

				// ԂA
				if(time == 0){
					// 
					init();
				}

				// uCN
				break;

		} // end switch

	} // end run

	/**
	 * `惁\bh.
	 * <pre>
	 * yCgKvƂɂ̃\bhĂяo܂B
	 * </pre>
	 */
	public void paint(Graphics g){

		// wi`悷
		g.drawImage(imageBackground, 0, 0, 800, 600, this);

		// `悷
		g.drawImage(imageMs[m], mx, my, 100, 100, this);

		// sRsRn}[`悷
		g.drawImage(imagePHs[ph], px, py, 100, 88, this);

		// _\
		g.setColor(Color.yellow);
		g.setFont(fontScore);
		g.drawString("_F" + score, 0, 24);

		// Q[̏ꍇA
		if(phase == 0){

			// Ԃ\
			g.setColor(Color.red);
			g.setFont(fontTime);
			g.drawString("c莞ԁF" + time / 60, 300, 24);

		// Q[I[o[̏ꍇA
		}else if(phase == 1){
			g.setColor(Color.lightGray);
			g.setFont(fontGameOver);
			g.drawString("Q[I[o[", 240, 300);

			// Rg
			if(score >= 30){
				g.drawString("ʂ̂", 240, 350);
			}else if(score >= 20){
				g.drawString("", 240, 350);
			}else if(score >= 10){
				g.drawString("܂܂", 240, 350);
			}else{
				g.drawString("΂̂", 240, 350);
			}

		} // end if Q[I[o[̏ꍇ

	} // end paint

	/**
	 * }EXA_v^
	 */
	private class MGMouseAdapter extends MouseAdapter {

		/**
		 * }EXꂽɌĂ΂܂
		 */
		public void mousePressed(MouseEvent me){

			// Q[̏ꍇA
			if(phase == 0){

				// sRsRn}[@
				ph = 1;
				// ꏊL
				px = me.getX() - 100;
				py = me.getY() - 100;

				// ĂȂꍇA
				if(m == 0){

					// Ƃ̓蔻
					if(px > mx - 50 && px < mx + 90 && py > my - 70 && py < my + 60){
						// ꂽ
						m = 1;
						timeM = 30;
						score++;
						// ʉX^[g
						wavePicoHammerHit.start();

					// OꂽꍇA
					}else{
						// ʉX^[g
						wavePicoHammerMiss.start();
					}

				} // end if ĂȂꍇ

			} // end if Q[̏ꍇ

		} //  end mousePressed

		/**
		 * }EXꂽɌĂ΂܂
		 */
		public void mouseReleased(MouseEvent me){

			// sRsRn}[グ
			ph = 0;
			// ꏊL
			px = me.getX() - 100;
			py = me.getY() - 100;

		} //  end mouseReleased

		/**
		 * }EXړꂽɌĂ΂܂
		 */
		public void mouseMoved(MouseEvent me){

			// ꏊL
			px = me.getX() - 100;
			py = me.getY() - 100;

		} //  end mouseMoved

		/**
		 * }EXhbOꂽɌĂ΂܂
		 */
		public void mouseDragged(MouseEvent me){

			// ꏊL
			px = me.getX() - 100;
			py = me.getY() - 100;

		} //  end mouseDragged

	} // end MGMouseAdapter

	/**
	 * ^C}[NX.
	 */
	private class TimerActionTimerTask extends TimerTask {

		public void run(){

			// s\bhĂяo
			MGPanel.this.run();

			// `悷
			repaint();

		} // end actionPerformed

	} // end TimerActionTimerTask

}
